#include "input.h"

void gameInput() {
	static uint8 mcont = 0;
	cont_cond_t cond;
  
	mcont = maple_controller_addr();
  
	if (!mcont) return;				/* No Controllers Found */

	if (cont_get_cond(mcont, &cond))
	{
		return;					/* Error getting controller status */
	}

	pRAM[0x7000] = 0xFF;				/* All bits high */
  
	if (cond.rtrig && cond.ltrig)			/* If both triggers are pulled... */
		Z80_Running = 0;				/* End Game */

	if (!(cond.buttons & CONT_Y))			/* Insert A Coin (bit 0 low) */
		pRAM[0x7000]&=~0x01;

	if (!(cond.buttons & CONT_START))		/* 1 Player Start (bit 1 low) */
		pRAM[0x7000]&=~0x02;

	if (!(cond.buttons & CONT_X))			/* 2 Player Start (bit 2 low) */
		pRAM[0x7000]&=~0x04;

	if (!(cond.buttons & CONT_A))			/* Fire gun (bit 4 low) */
 		pRAM[0x7000]&=~0x10;

	if (!(cond.buttons & CONT_DPAD_RIGHT))	/* Move Ship Right (bit 5 low) */
		pRAM[0x7000]&=~0x20;

	if (!(cond.buttons & CONT_DPAD_LEFT))	/* Move Ship Left (bit 6 low) */
		pRAM[0x7000]&=~0x40;

	if (!(cond.buttons & CONT_B))			/* Barrier (Sheild) (bit 7 low) */
		pRAM[0x7000]&=~0x80;
}