#include "global.h"
#include "mem.h"
#include "video.h"

int Z80_Iperiod=720000/60;
int Z80_IRQ=0;

int main()
{
	serial_disable();					/* I use the BBA so i disable serial... */
	dc_setup_quiet(DM_640x480,PM_RGB565);
	ta_init();
	vramBank = 0;					/* Setup some starting values for some vars */
	palette = 1;

	ta_bkg.flags1 = 0x90800000;
	ta_bkg.flags2 = 0x20800440;
	ta_bkg.dummy = 0;
	ta_bkg.x1 = 0.0f;
	ta_bkg.y1 = 480.0f;
	ta_bkg.z1 = 0.2f;
	ta_bkg.argb1 = 0xff000000;
	ta_bkg.x2 = 0.0f;
	ta_bkg.y2 = 0.0f;
	ta_bkg.z3 = 0.2f;
	ta_bkg.argb2 = 0xff000000;
	ta_bkg.x3 = 640.0f;
	ta_bkg.y3 = 480.0f;
	ta_bkg.z3 = 0.2f;
	ta_bkg.argb3 = 0xff000000;
	
	if(!allocateMem()) return 0;			/* Allocate the memory we need */
	loadGame();						/* Load the roms into pRAM */
	Z80_Reset();
	Z80();						/* Start the CPU emulation */

	dc_setup_quiet(DM_640x480,PM_RGB565);
	(*(void(**)())0x8c0000e0)(1);			/* I borrowed this from DCPhoenix, it exits */
	return 1;
}

int Z80_Interrupt()
{
	drawScreen();
	pRAM[0x7800]|=0x80;				/* Set VBlank bit in the dipswitches */
	return(Z80_IGNORE_INT);
}


/* These are required to please the Z80 emu i use */
byte Z80_In(byte Port) {return 0;}
void Z80_Out(byte Port,byte Value) {}
void Z80_Patch(Z80_Regs *R) {}
void Z80_Reti() {}
void Z80_Retn() {}